## rust-proxmox-offline-mirror 0.6.6

=== Makefile ===
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include defines.mk

PACKAGE=proxmox-offline-mirror
BUILDDIR ?= $(PACKAGE)-$(DEB_VERSION_UPSTREAM)

SUBDIRS := docs

DEB=$(PACKAGE)_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_HOST_ARCH).deb
HELPER_DEB=$(PACKAGE)-helper_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_HOST_ARCH).deb
DBG_DEB=$(PACKAGE)-dbgsym_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_HOST_ARCH).deb
HELPER_DBG_DEB=$(PACKAGE)-helper-dbgsym_$(DEB_VERSION_UPSTREAM_REVISION)_$(DEB_HOST_ARCH).deb
DOC_DEB=$(PACKAGE)-docs_$(DEB_VERSION_UPSTREAM_REVISION)_all.deb
DSC=rust-$(PACKAGE)_$(DEB_VERSION_UPSTREAM_REVISION).dsc

DEBS = $(DEB) $(HELPER_DEB) $(DBG_DEB) $(HELPER_DBG_DEB) $(DOC_DEB)

ifeq ($(BUILD_MODE), release)
CARGO_BUILD_ARGS += --release
COMPILEDIR := target/release
else ifeq ($(BUILD_MODE), release-deb)
CARGO_BUILD_ARGS += --release
COMPILEDIR := target/$(DEB_HOST_RUST_TYPE)/release
else
COMPILEDIR := target/debug
endif

CARGO ?= cargo

USR_BIN := \
	proxmox-offline-mirror \
	proxmox-offline-mirror-helper

COMPILED_BINS := \
	$(addprefix $(COMPILEDIR)/,$(USR_BIN))

all: cargo-build $(SUBDIRS)

.PHONY: cargo-build
cargo-build:
	$(CARGO) build $(CARGO_BUILD_ARGS)

.PHONY: $(SUBDIRS)
$(SUBDIRS): cargo-build
	$(MAKE) -C $@

$(COMPILED_BINS): cargo-build

install: $(COMPILED_BINS)
	$(MAKE) -C docs install DESTDIR=../debian/proxmox-offline-mirror-docs
	install -dm755 $(DESTDIR)$(BINDIR)
	$(foreach i,$(USR_BIN), \
	    install -m755 $(COMPILEDIR)/$(i) $(DESTDIR)$(BINDIR)/ ;)

update-dcontrol: #$(BUILDDIR)
	debcargo package \
	  --config debian/debcargo.toml \
	  --changelog-ready \
	  --no-overlay-write-back \
	  --directory $(BUILDDIR) \
	  $(PACKAGE) \
	  $(shell dpkg-parsechangelog -l debian/changelog -SVersion | sed -e 's/-.*//')
	cat $(BUILDDIR)/debian/control debian/control.extra > debian/control
	wrap-and-sort -t -k -f debian/control

.PHONY: build
build: $(BUILDDIR)
$(BUILDDIR):
	rm -rf $@ $@.tmp; mkdir $@.tmp
	cp -a src docs debian Cargo.toml Makefile defines.mk $@.tmp/
	mv $@.tmp $@

.PHONY: deb
deb: $(DEB)
$(HELPER_DEB) $(DBG_DEB) $(HELPER_DBG_DEB) $(DOC_DEB): $(DEB)
$(DEB): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -b -us -uc --no-pre-clean
	lintian $(DEB) $(DOC_DEB) $(HELPER_DEB)

.PHONY: dsc
dsc:
	rm -rf $(BUILDDIR) $(DSC)
	$(MAKE) $(DSC)
	lintian $(DSC)
$(DSC): $(BUILDDIR)
	cd $(BUILDDIR); dpkg-buildpackage -S -us -uc -d -nc

sbuild: $(DSC)
	sbuild $<

.PHONY: dinstall
dinstall: $(DEB)
	dpkg -i $(DEB) $(DBG_DEB) $(DOC_DEB)

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: $(DEBS)
	tar cf - $(DEBS) | ssh -X repoman@repo.proxmox.com -- upload --product pve,pmg,pbs,pbs-client --dist $(UPLOAD_DIST) --arch $(DEB_HOST_ARCH)

.PHONY: distclean
distclean: clean

.PHONY: clean
clean:
	$(CARGO) clean
	rm -f *.deb *.build *.buildinfo *.changes *.dsc rust-$(PACKAGE)*.tar*
	rm -rf $(PACKAGE)-[0-9]*/
	find . -name '*~' -exec rm {} ';'

=== docs/Makefile ===
include ../defines.mk

GENERATED_SYNOPSIS := \
	proxmox-offline-mirror/synopsis.rst \
	proxmox-offline-mirror-helper/synopsis.rst \
	config/mirror/config.rst

MAN1_PAGES := \
	proxmox-offline-mirror.1 \
	proxmox-offline-mirror-helper.1

MAN5_PAGES := \
	proxmox-offline-mirror.cfg.5

EXAMPLE_FILES := \
	examples/nginx-conf

# Sphinx documentation setup
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
BUILDDIR      = output

ifeq ($(BUILD_MODE), release)
COMPILEDIR := ../target/$release
SPHINXOPTS    += -t release
else ifeq ($(BUILD_MODE), release-deb)
COMPILEDIR := ../target/$(DEB_HOST_RUST_TYPE)/release
SPHINXOPTS    += -t release
else
COMPILEDIR := ../target/debug
SPHINXOPTS    += -t devbuild
endif

# Sphinx internal variables.
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(SPHINXOPTS) .

all: $(MAN1_PAGES) $(MAN5_PAGES)

config/%/config.rst: $(COMPILEDIR)/docgen
	$(COMPILEDIR)/docgen $*.cfg >$@

%/synopsis.rst: $(COMPILEDIR)/%
	$< printdoc > $@

$(MAN1_PAGES) $(MAN5_PAGES): man-pages

.PHONY: man-pages
man-pages: $(GENERATED_SYNOPSIS)
	$(SPHINXBUILD) $(SPHINXOPTS) -b man ./ $(BUILDDIR)/man

.PHONY: html
html: $(GENERATED_SYNOPSIS) images/proxmox-logo.svg custom.css conf.py $(PRUNE_SIMULATOR_FILES) $(LTO_BARCODE_FILES) $(API_VIEWER_SOURCES) $(EXAMPLE_FILES)
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	install -m 0644 custom.js custom.css images/proxmox-logo.svg $(BUILDDIR)/html/_static/
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: latexpdf
latexpdf: $(GENERATED_SYNOPSIS)
	@echo "Requires python3-sphinx, texlive-xetex, xindy and texlive-fonts-extra"
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through xelatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "xelatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: epub3
epub3: $(GENERATED_SYNOPSIS)
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

clean:
	rm -r -f *~ *.1 $(BUILDDIR) $(GENERATED_SYNOPSIS)

install_manual_pages: man-pages
	install -dm755 $(DESTDIR)$(MAN1DIR)
	for i in $(MAN1_PAGES); do install -m755 $(BUILDDIR)/man/$$i $(DESTDIR)$(MAN1DIR)/ ; done
	install -dm755 $(DESTDIR)$(MAN5DIR)
	for i in $(MAN5_PAGES); do install -m755 $(BUILDDIR)/man/$$i $(DESTDIR)$(MAN5DIR)/ ; done

install_html: html
	install -dm755 $(DESTDIR)$(DOCDIR)
	rsync -a $(BUILDDIR)/html $(DESTDIR)$(DOCDIR)

install_pdf: latexpdf
	install -dm755 $(DESTDIR)$(DOCDIR)
	install -m 0644 output/latex/ProxmoxOfflineMirror.pdf $(DESTDIR)$(DOCDIR)/proxmox-offline-mirror.pdf

install_examples: $(EXAMPLE_FILES)
	install -dm755 $(DESTDIR)$(DOCDIR)/examples
	install -m 0644 examples/nginx-conf $(DESTDIR)$(DOCDIR)/examples

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)

install: install_manual_pages

else

install: install_manual_pages install_html install_pdf install_examples

endif

=== debian/changelog ===
rust-proxmox-offline-mirror (0.6.6) bookworm; urgency=medium

  * fix #5249: apt: allow parsing Packages without Priority field

 -- Proxmox Support Team <support@proxmox.com>  Fri, 19 Apr 2024 09:01:51 +0200

rust-proxmox-offline-mirror (0.6.5) bookworm; urgency=medium

  * docs: fix version and release numbers

 -- Proxmox Support Team <support@proxmox.com>  Wed, 21 Feb 2024 12:15:50 +0100

rust-proxmox-offline-mirror (0.6.4) bookworm; urgency=medium

  * helper: improve handling of multiple keys when activating them

  * docs: add an auto dark mode to the docs

  * weak crypto: actually honor RSA config option

  * docs: offline-media: Use correct config subcommand

  * minor code cleanup

 -- Proxmox Support Team <support@proxmox.com>  Tue, 09 Jan 2024 09:33:28 +0100

rust-proxmox-offline-mirror (0.6.3) bookworm; urgency=medium

  * add non-free-firmware to bookworm default components

  * docs: fix bullseye references

  * docs: fix copied env variable documentation

  * add support for ceph reef

  * add missing subscription setting for ceph enterprise repos

 -- Proxmox Support Team <support@proxmox.com>  Sat, 25 Nov 2023 17:22:31 +0100

rust-proxmox-offline-mirror (0.6.2) bookworm; urgency=medium

  * d/rules: patch out wrongly linked libraries from ELFs

  * release file: extend component fixup for Debian security repo also to
    bookworm suite

 -- Proxmox Support Team <support@proxmox.com>  Thu, 29 Jun 2023 15:04:12 +0200

rust-proxmox-offline-mirror (0.6.1) bookworm; urgency=medium

  * add support for bookworm enterprise ceph repo

  * add bookworm to the list of releases for easier set up

 -- Proxmox Support Team <support@proxmox.com>  Fri, 16 Jun 2023 09:29:40 +0200

rust-proxmox-offline-mirror (0.6.0) bookworm; urgency=medium

  * re-build for Debian Bookworm based release

  * switch to native versioning

 -- Proxmox Support Team <support@proxmox.com>  Tue, 30 May 2023 13:05:47 +0200

rust-proxmox-offline-mirror (0.5.1-1) bullseye; urgency=medium

  * fix #4445: add proxy support by honoring ALL_PROXY environment variable
    for mirroring and subscription management

  * docs: document `ALL_PROXY` environment variable

 -- Proxmox Support Team <support@proxmox.com>  Tue, 07 Feb 2023 15:35:17 +0100

rust-proxmox-offline-mirror (0.5.0-1) stable; urgency=medium

  * fix #4259: mirror: add 'ignore-errors' option to make fetching errors from
    (technically) broken repositories non-fatal.

  * mirror: collect and summarize warnings to ensure that they ain't missed in
    the rather verbose output

  * pool: add a 'diff' command for snapshots and for mediums, to ease
    comparing the actual changes

  * mirror snapshot list: make the <id> parameter optional so that one can
    quickly list all snapshots from all mirrors.

  * mirror: add option to configure filtering one or more packages via GLOBs
    and also specific Debian packaging sections like 'games', 'kernel' or
    'debug' to reduce the pool size

  * mirror: implement source packages mirroring

  * fix #4264: only require either Release or InRelease as even though that
    InRelease is strictly speaking required, some repos (especially older
    ones) may not have it.

  * guided mirror setup: propose to filter out the 'games' and 'debug'
    sections by default, which, for example, reduces a mirror of PVE + Debian
    bullseye by about 27% (105GB->77GB).

  * docs: mention the new section and package filters

  * helper: add status command for showing information that is stored on the
    medium itself

  * guided setup: add Quincy as supported release for bullseye

 -- Proxmox Support Team <support@proxmox.com>  Sat, 22 Oct 2022 17:01:07 +0200

rust-proxmox-offline-mirror (0.4.0-1) stable; urgency=medium

  * docs: add minimal sample nginx config

  * docs: offline keys: add info about minimum product version that got
    activation support

  * docs: expand/structure "using medium" section

  * mirror: use xz multi decoder to be compatible with Ubuntu and similar
    usage of xz

  * mirror: skip failed, non Packages references for better compat with
    non-Debian/Proxmox repos

  * mirror: handle indices which are only available compressed and support
    acquiring them by hash

  * mirror: add --dry-run parameter

  * cli: add `mirror snapshot create-all` command, which creates a new
    snapshot for each configured mirror. This should be suitable for usage in
    a cron job or systemd timer-triggered unit

 -- Proxmox Support Team <support@proxmox.com>  Fri, 16 Sep 2022 14:25:59 +0200

rust-proxmox-offline-mirror (0.3.0-1) stable; urgency=medium

  * pool: allow pool re-use (breaking change!)

  * pool: improve sync progress reporting

  * docs: lots of improvements

  * rename proxmox-apt-repo to proxmox-offline-mirror-helper

  * move proxmox-offline-mirror-helper into own package

 -- Proxmox Support Team <support@proxmox.com>  Fri, 9 Sep 2022 13:50:43 +0200

rust-proxmox-offline-mirror (0.2.0-1) stable; urgency=medium

  * split out docs package

  * update proxmox dependencies to reduces indirect, transitive dependencies

  * keys: improve output on add/refresh

  * wizard: ask for new medium ID up front

  * docs pdf: avoid extra blank page on section/chapter boundary

  * docs: restructure and split in different chapter files

  * docs: add installation chapter

  * medium: implement `remove .. --remove-data`

  * wizard: optionally auto-add Debian mirrors

  * wizard: query base path for location

  * docs: ship config manpage as proxmox-offline-mirror.cfg.5

 -- Proxmox Support Team <support@proxmox.com>  Thu, 08 Sep 2022 13:46:05 +0200

rust-proxmox-offline-mirror (0.1.0-1) stable; urgency=medium

  * initial release

 -- Proxmox Support Team <support@proxmox.com>  Tue, 6 Sep 2022 09:54:10 +0200

=== debian/control ===
Source: rust-proxmox-offline-mirror
Section: rust
Priority: optional
Build-Depends: bash-completion,
               cargo:native,
               debhelper-compat (= 13),
               dh-cargo (>= 25),
               fonts-lato,
               fonts-open-sans,
               latexmk,
               librust-anyhow-1+default-dev,
               librust-base64-0.13+default-dev,
               librust-bzip2-0.4+default-dev,
               librust-flate2-1+default-dev (>= 1.0.22-~~),
               librust-globset-0.4+default-dev (>= 0.4.8-~~),
               librust-hex-0.4+default-dev (>= 0.4.3-~~),
               librust-nix-0.26+default-dev (>= 0.26.1-~~),
               librust-openssl-0.10+default-dev,
               librust-proxmox-apt-0.11+default-dev,
               librust-proxmox-apt-api-types-1+default-dev,
               librust-proxmox-async-0.4+default-dev,
               librust-proxmox-http-0.9+client-sync-dev,
               librust-proxmox-http-0.9+client-trait-dev,
               librust-proxmox-http-0.9+default-dev,
               librust-proxmox-router-2+cli-dev,
               librust-proxmox-schema-3+api-macro-dev (>= 3.1.4-~~),
               librust-proxmox-schema-3+default-dev (>= 3.1.4-~~),
               librust-proxmox-section-config-2+default-dev,
               librust-proxmox-serde-0.1+default-dev,
               librust-proxmox-subscription-0.4+api-types-dev (>= 0.4.2-~~),
               librust-proxmox-subscription-0.4+default-dev (>= 0.4.2-~~),
               librust-proxmox-sys-0.6+default-dev,
               librust-proxmox-sys-0.6+timer-dev,
               librust-proxmox-time-2+default-dev,
               librust-regex-1+default-dev (>= 1.5.5-~~),
               librust-sequoia-openpgp-1+default-dev (>= 1.12-~~),
               librust-serde-1+default-dev,
               librust-serde-1+derive-dev,
               librust-serde-json-1+default-dev,
               librust-walkdir-2+default-dev (>= 2.3.1-~~),
               librust-xz2-0.1+default-dev,
               libstd-rust-dev,
               patchelf,
               python3-sphinx,
               rsync,
               rustc:native,
               texlive-fonts-recommended,
               texlive-xetex,
Maintainer: Proxmox Support Team <support@proxmox.com>
Standards-Version: 4.6.1
Vcs-Git: git://git.proxmox.com/git/proxmox-offline-mirror.git
Vcs-Browser: https://git.proxmox.com/?p=proxmox-offline-mirror.git
X-Cargo-Crate: proxmox-offline-mirror
Rules-Requires-Root: no

Package: proxmox-offline-mirror
Architecture: any
Multi-Arch: allowed
Section: admin
Depends: proxmox-archive-keyring,
         proxmox-offline-mirror-docs,
         ${cargo:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ${cargo:Recommends},
Suggests: ${cargo:Suggests},
Provides: ${cargo:Provides},
Built-Using: ${cargo:Built-Using},
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Proxmox offline repository mirror and subscription key manager
 This package contains the proxmox-offline-mirror tool for managing Proxmox
 offline APT
 repositories and subscription keys.

Package: proxmox-offline-mirror-docs
Architecture: all
Section: admin
Depends: ${misc:Depends},
Breaks: proxmox-offline-mirror (<< 0.2.0~),
Replaces: proxmox-offline-mirror (<< 0.2.0~),
Description: Proxmox offline repository mirror and subscription key manager
 This package contains the documentation for proxmox-offline-mirror.

Package: proxmox-offline-mirror-helper
Architecture: any
Multi-Arch: allowed
Section: admin
Depends: proxmox-archive-keyring,
         proxmox-offline-mirror-docs,
         ${cargo:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: ${cargo:Recommends},
Suggests: ${cargo:Suggests},
Provides: ${cargo:Provides},
Breaks: proxmox-offline-mirror (<< 0.3.0~),
Replaces: proxmox-offline-mirror (<< 0.3.0~),
Built-Using: ${cargo:Built-Using},
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Proxmox offline repository mirror and subscription key manager helper
 This package contains the proxmox-offline-mirror-helper binary for managing
 Proxmox offline APT repositories and subscription keys on Proxmox offline
 systems.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/rustc/architecture.mk

export BUILD_MODE=release-deb

export CARGO=/usr/share/cargo/bin/cargo

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export CARGO_HOME=$(CURDIR)/debian/cargo_home

export DEB_CARGO_CRATE=proxmox-offline-mirror_$(DEB_VERSION_UPSTREAM)
export DEB_CARGO_PACKAGE=proxmox-offline-mirror

# for docs build
export DEB_VERSION DEB_VERSION_UPSTREAM

%:
	dh $@ --with=bash-completion

override_dh_auto_configure:
	@perl -ne 'if (/^version\s*=\s*"(\d+(?:\.\d+)+)"/) { my $$v_cargo = $$1; my $$v_deb = "$(DEB_VERSION_UPSTREAM)"; \
	    die "ERROR: d/changelog <-> Cargo.toml version mismatch: $$v_cargo != $$v_deb\n" if $$v_cargo ne $$v_deb; exit(0); }' Cargo.toml
	$(CARGO) prepare-debian $(CURDIR)/debian/cargo_registry --link-from-system
	# `cargo build` and `cargo install` have different config precedence, symlink
	# the wrapper config into a place where `build` picks it up as well..
	# https://doc.rust-lang.org/cargo/commands/cargo-install.html#configuration-discovery
	mkdir -p $(CURDIR)/.cargo
	ln -s $(CARGO_HOME)/config.toml $(CURDIR)/.cargo/config.toml
	dh_auto_configure

override_dh_auto_test:
	# skip for now to avoid additional debug builds - no tests anyway
	# dh_auto_test -- test --all

execute_after_dh_auto_install:
	/usr/share/cargo/bin/dh-cargo-built-using $(DEB_CARGO_PACKAGE)

override_dh_missing:
	dh_missing --fail-missing

override_dh_compress:
	dh_compress -X.pdf

override_dh_strip:
	dh_strip
	for exe in $$(find \
	    debian/proxmox-offline-mirror/usr \
	    debian/proxmox-offline-mirror-helper/usr \
	    -executable -type f); \
	do \
	  debian/scripts/elf-strip-unused-dependencies.sh "$$exe" || true; \
	done
